# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

CONNECTOMEEDIT_METADATA = Metadata(
    id="a299cc4eb27663a67fd9b0e7c142c297b8c23d7f.boutiques",
    name="connectomeedit",
    package="mrtrix",
    container_image_tag="mrtrix3/mrtrix3:3.0.4",
)


ConnectomeeditConfigParameters = typing.TypedDict('ConnectomeeditConfigParameters', {
    "__STYX_TYPE__": typing.Literal["config"],
    "key": str,
    "value": str,
})


ConnectomeeditParameters = typing.TypedDict('ConnectomeeditParameters', {
    "__STYX_TYPE__": typing.Literal["connectomeedit"],
    "info": bool,
    "quiet": bool,
    "debug": bool,
    "force": bool,
    "nthreads": typing.NotRequired[int | None],
    "config": typing.NotRequired[list[ConnectomeeditConfigParameters] | None],
    "help": bool,
    "version": bool,
    "input": str,
    "operation": str,
    "output": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "connectomeedit": connectomeedit_cargs,
        "config": connectomeedit_config_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


def connectomeedit_config_params(
    key: str,
    value: str,
) -> ConnectomeeditConfigParameters:
    """
    Build parameters.
    
    Args:
        key: temporarily set the value of an MRtrix config file entry.
        value: temporarily set the value of an MRtrix config file entry.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "config",
        "key": key,
        "value": value,
    }
    return params


def connectomeedit_config_cargs(
    params: ConnectomeeditConfigParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("-config")
    cargs.append(params.get("key"))
    cargs.append(params.get("value"))
    return cargs


class ConnectomeeditOutputs(typing.NamedTuple):
    """
    Output object returned when calling `connectomeedit(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def connectomeedit_params(
    input_: str,
    operation: str,
    output: str,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[ConnectomeeditConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
) -> ConnectomeeditParameters:
    """
    Build parameters.
    
    Args:
        input_: the input connectome.
        operation: the operation to apply, one of: to_symmetric,\
            upper_triangular, lower_triangular, transpose, zero_diagonal.
        output: the output connectome.
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "connectomeedit",
        "info": info,
        "quiet": quiet,
        "debug": debug,
        "force": force,
        "help": help_,
        "version": version,
        "input": input_,
        "operation": operation,
        "output": output,
    }
    if nthreads is not None:
        params["nthreads"] = nthreads
    if config is not None:
        params["config"] = config
    return params


def connectomeedit_cargs(
    params: ConnectomeeditParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("connectomeedit")
    if params.get("info"):
        cargs.append("-info")
    if params.get("quiet"):
        cargs.append("-quiet")
    if params.get("debug"):
        cargs.append("-debug")
    if params.get("force"):
        cargs.append("-force")
    if params.get("nthreads") is not None:
        cargs.extend([
            "-nthreads",
            str(params.get("nthreads"))
        ])
    if params.get("config") is not None:
        cargs.extend([a for c in [dyn_cargs(s["__STYXTYPE__"])(s, execution) for s in params.get("config")] for a in c])
    if params.get("help"):
        cargs.append("-help")
    if params.get("version"):
        cargs.append("-version")
    cargs.append(params.get("input"))
    cargs.append(params.get("operation"))
    cargs.append(params.get("output"))
    return cargs


def connectomeedit_outputs(
    params: ConnectomeeditParameters,
    execution: Execution,
) -> ConnectomeeditOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = ConnectomeeditOutputs(
        root=execution.output_file("."),
    )
    return ret


def connectomeedit_execute(
    params: ConnectomeeditParameters,
    execution: Execution,
) -> ConnectomeeditOutputs:
    """
    Perform basic operations on a connectome.
    
    
    
    References:
    
    .
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `ConnectomeeditOutputs`).
    """
    params = execution.params(params)
    cargs = connectomeedit_cargs(params, execution)
    ret = connectomeedit_outputs(params, execution)
    execution.run(cargs)
    return ret


def connectomeedit(
    input_: str,
    operation: str,
    output: str,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[ConnectomeeditConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
    runner: Runner | None = None,
) -> ConnectomeeditOutputs:
    """
    Perform basic operations on a connectome.
    
    
    
    References:
    
    .
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        input_: the input connectome.
        operation: the operation to apply, one of: to_symmetric,\
            upper_triangular, lower_triangular, transpose, zero_diagonal.
        output: the output connectome.
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `ConnectomeeditOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(CONNECTOMEEDIT_METADATA)
    params = connectomeedit_params(
        info=info,
        quiet=quiet,
        debug=debug,
        force=force,
        nthreads=nthreads,
        config=config,
        help_=help_,
        version=version,
        input_=input_,
        operation=operation,
        output=output,
    )
    return connectomeedit_execute(params, execution)


__all__ = [
    "CONNECTOMEEDIT_METADATA",
    "ConnectomeeditConfigParameters",
    "ConnectomeeditOutputs",
    "ConnectomeeditParameters",
    "connectomeedit",
    "connectomeedit_config_params",
    "connectomeedit_params",
]
