# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MRCLUSTERSTATS_METADATA = Metadata(
    id="c57e5e73fb4141a5486cb8917fc726340ee4455f.boutiques",
    name="mrclusterstats",
    package="mrtrix",
    container_image_tag="mrtrix3/mrtrix3:3.0.4",
)


MrclusterstatsColumnParameters = typing.TypedDict('MrclusterstatsColumnParameters', {
    "__STYX_TYPE__": typing.Literal["column"],
    "path": InputPathType,
})


MrclusterstatsConfigParameters = typing.TypedDict('MrclusterstatsConfigParameters', {
    "__STYX_TYPE__": typing.Literal["config"],
    "key": str,
    "value": str,
})


MrclusterstatsParameters = typing.TypedDict('MrclusterstatsParameters', {
    "__STYX_TYPE__": typing.Literal["mrclusterstats"],
    "notest": bool,
    "errors": typing.NotRequired[str | None],
    "exchange_within": typing.NotRequired[InputPathType | None],
    "exchange_whole": typing.NotRequired[InputPathType | None],
    "strong": bool,
    "nshuffles": typing.NotRequired[int | None],
    "permutations": typing.NotRequired[InputPathType | None],
    "nonstationarity": bool,
    "skew_nonstationarity": typing.NotRequired[float | None],
    "nshuffles_nonstationarity": typing.NotRequired[int | None],
    "permutations_nonstationarity": typing.NotRequired[InputPathType | None],
    "tfce_dh": typing.NotRequired[float | None],
    "tfce_e": typing.NotRequired[float | None],
    "tfce_h": typing.NotRequired[float | None],
    "variance": typing.NotRequired[InputPathType | None],
    "ftests": typing.NotRequired[InputPathType | None],
    "fonly": bool,
    "column": typing.NotRequired[list[MrclusterstatsColumnParameters] | None],
    "threshold": typing.NotRequired[float | None],
    "connectivity": bool,
    "info": bool,
    "quiet": bool,
    "debug": bool,
    "force": bool,
    "nthreads": typing.NotRequired[int | None],
    "config": typing.NotRequired[list[MrclusterstatsConfigParameters] | None],
    "help": bool,
    "version": bool,
    "input": InputPathType,
    "design": InputPathType,
    "contrast": InputPathType,
    "mask": InputPathType,
    "output": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "mrclusterstats": mrclusterstats_cargs,
        "column": mrclusterstats_column_cargs,
        "config": mrclusterstats_config_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
    }.get(t)


def mrclusterstats_column_params(
    path: InputPathType,
) -> MrclusterstatsColumnParameters:
    """
    Build parameters.
    
    Args:
        path: add a column to the design matrix corresponding to subject\
            voxel-wise values (note that the contrast matrix must include an\
            additional column for each use of this option); the text file provided\
            via this option should contain a file name for each subject.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "column",
        "path": path,
    }
    return params


def mrclusterstats_column_cargs(
    params: MrclusterstatsColumnParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("-column")
    cargs.append(execution.input_file(params.get("path")))
    return cargs


def mrclusterstats_config_params(
    key: str,
    value: str,
) -> MrclusterstatsConfigParameters:
    """
    Build parameters.
    
    Args:
        key: temporarily set the value of an MRtrix config file entry.
        value: temporarily set the value of an MRtrix config file entry.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "config",
        "key": key,
        "value": value,
    }
    return params


def mrclusterstats_config_cargs(
    params: MrclusterstatsConfigParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("-config")
    cargs.append(params.get("key"))
    cargs.append(params.get("value"))
    return cargs


class MrclusterstatsOutputs(typing.NamedTuple):
    """
    Output object returned when calling `mrclusterstats(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""


def mrclusterstats_params(
    input_: InputPathType,
    design: InputPathType,
    contrast: InputPathType,
    mask: InputPathType,
    output: str,
    notest: bool = False,
    errors: str | None = None,
    exchange_within: InputPathType | None = None,
    exchange_whole: InputPathType | None = None,
    strong: bool = False,
    nshuffles: int | None = None,
    permutations: InputPathType | None = None,
    nonstationarity: bool = False,
    skew_nonstationarity: float | None = None,
    nshuffles_nonstationarity: int | None = None,
    permutations_nonstationarity: InputPathType | None = None,
    tfce_dh: float | None = None,
    tfce_e: float | None = None,
    tfce_h: float | None = None,
    variance: InputPathType | None = None,
    ftests: InputPathType | None = None,
    fonly: bool = False,
    column: list[MrclusterstatsColumnParameters] | None = None,
    threshold: float | None = None,
    connectivity: bool = False,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[MrclusterstatsConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
) -> MrclusterstatsParameters:
    """
    Build parameters.
    
    Args:
        input_: a text file containing the file names of the input images, one\
            file per line.
        design: the design matrix.
        contrast: the contrast matrix.
        mask: a mask used to define voxels included in the analysis.
        output: the filename prefix for all output.
        notest: don't perform statistical inference; only output population\
            statistics (effect size, stdev etc).
        errors: specify nature of errors for shuffling; options are:\
            ee,ise,both (default: ee).
        exchange_within: specify blocks of observations within each of which\
            data may undergo restricted exchange.
        exchange_whole: specify blocks of observations that may be exchanged\
            with one another (for independent and symmetric errors, sign-flipping\
            will occur block-wise).
        strong: use strong familywise error control across multiple hypotheses.
        nshuffles: the number of shuffles (default: 5000).
        permutations: manually define the permutations (relabelling). The input\
            should be a text file defining a m x n matrix, where each relabelling\
            is defined as a column vector of size m, and the number of columns, n,\
            defines the number of permutations. Can be generated with the\
            palm_quickperms function in PALM\
            (http://fsl.fmrib.ox.ac.uk/fsl/fslwiki/PALM). Overrides the -nshuffles\
            option.
        nonstationarity: perform non-stationarity correction.
        skew_nonstationarity: specify the skew parameter for empirical\
            statistic calculation (default for this command is 1).
        nshuffles_nonstationarity: the number of shuffles to use when\
            precomputing the empirical statistic image for non-stationarity\
            correction (default: 5000).
        permutations_nonstationarity: manually define the permutations\
            (relabelling) for computing the emprical statistics for\
            non-stationarity correction. The input should be a text file defining a\
            m x n matrix, where each relabelling is defined as a column vector of\
            size m, and the number of columns, n, defines the number of\
            permutations. Can be generated with the palm_quickperms function in\
            PALM (http://fsl.fmrib.ox.ac.uk/fsl/fslwiki/PALM) Overrides the\
            -nshuffles_nonstationarity option.
        tfce_dh: the height increment used in the tfce integration (default:\
            0.1).
        tfce_e: tfce extent exponent (default: 0.5).
        tfce_h: tfce height exponent (default: 2).
        variance: define variance groups for the G-statistic; measurements for\
            which the expected variance is equivalent should contain the same index.
        ftests: perform F-tests; input text file should contain, for each\
            F-test, a row containing ones and zeros, where ones indicate the rows\
            of the contrast matrix to be included in the F-test.
        fonly: only assess F-tests; do not perform statistical inference on\
            entries in the contrast matrix.
        column: add a column to the design matrix corresponding to subject\
            voxel-wise values (note that the contrast matrix must include an\
            additional column for each use of this option); the text file provided\
            via this option should contain a file name for each subject.
        threshold: the cluster-forming threshold to use for a standard\
            cluster-based analysis. This disables TFCE, which is the default\
            otherwise.
        connectivity: use 26-voxel-neighbourhood connectivity (Default: 6).
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "mrclusterstats",
        "notest": notest,
        "strong": strong,
        "nonstationarity": nonstationarity,
        "fonly": fonly,
        "connectivity": connectivity,
        "info": info,
        "quiet": quiet,
        "debug": debug,
        "force": force,
        "help": help_,
        "version": version,
        "input": input_,
        "design": design,
        "contrast": contrast,
        "mask": mask,
        "output": output,
    }
    if errors is not None:
        params["errors"] = errors
    if exchange_within is not None:
        params["exchange_within"] = exchange_within
    if exchange_whole is not None:
        params["exchange_whole"] = exchange_whole
    if nshuffles is not None:
        params["nshuffles"] = nshuffles
    if permutations is not None:
        params["permutations"] = permutations
    if skew_nonstationarity is not None:
        params["skew_nonstationarity"] = skew_nonstationarity
    if nshuffles_nonstationarity is not None:
        params["nshuffles_nonstationarity"] = nshuffles_nonstationarity
    if permutations_nonstationarity is not None:
        params["permutations_nonstationarity"] = permutations_nonstationarity
    if tfce_dh is not None:
        params["tfce_dh"] = tfce_dh
    if tfce_e is not None:
        params["tfce_e"] = tfce_e
    if tfce_h is not None:
        params["tfce_h"] = tfce_h
    if variance is not None:
        params["variance"] = variance
    if ftests is not None:
        params["ftests"] = ftests
    if column is not None:
        params["column"] = column
    if threshold is not None:
        params["threshold"] = threshold
    if nthreads is not None:
        params["nthreads"] = nthreads
    if config is not None:
        params["config"] = config
    return params


def mrclusterstats_cargs(
    params: MrclusterstatsParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("mrclusterstats")
    if params.get("notest"):
        cargs.append("-notest")
    if params.get("errors") is not None:
        cargs.extend([
            "-errors",
            params.get("errors")
        ])
    if params.get("exchange_within") is not None:
        cargs.extend([
            "-exchange_within",
            execution.input_file(params.get("exchange_within"))
        ])
    if params.get("exchange_whole") is not None:
        cargs.extend([
            "-exchange_whole",
            execution.input_file(params.get("exchange_whole"))
        ])
    if params.get("strong"):
        cargs.append("-strong")
    if params.get("nshuffles") is not None:
        cargs.extend([
            "-nshuffles",
            str(params.get("nshuffles"))
        ])
    if params.get("permutations") is not None:
        cargs.extend([
            "-permutations",
            execution.input_file(params.get("permutations"))
        ])
    if params.get("nonstationarity"):
        cargs.append("-nonstationarity")
    if params.get("skew_nonstationarity") is not None:
        cargs.extend([
            "-skew_nonstationarity",
            str(params.get("skew_nonstationarity"))
        ])
    if params.get("nshuffles_nonstationarity") is not None:
        cargs.extend([
            "-nshuffles_nonstationarity",
            str(params.get("nshuffles_nonstationarity"))
        ])
    if params.get("permutations_nonstationarity") is not None:
        cargs.extend([
            "-permutations_nonstationarity",
            execution.input_file(params.get("permutations_nonstationarity"))
        ])
    if params.get("tfce_dh") is not None:
        cargs.extend([
            "-tfce_dh",
            str(params.get("tfce_dh"))
        ])
    if params.get("tfce_e") is not None:
        cargs.extend([
            "-tfce_e",
            str(params.get("tfce_e"))
        ])
    if params.get("tfce_h") is not None:
        cargs.extend([
            "-tfce_h",
            str(params.get("tfce_h"))
        ])
    if params.get("variance") is not None:
        cargs.extend([
            "-variance",
            execution.input_file(params.get("variance"))
        ])
    if params.get("ftests") is not None:
        cargs.extend([
            "-ftests",
            execution.input_file(params.get("ftests"))
        ])
    if params.get("fonly"):
        cargs.append("-fonly")
    if params.get("column") is not None:
        cargs.extend([a for c in [dyn_cargs(s["__STYXTYPE__"])(s, execution) for s in params.get("column")] for a in c])
    if params.get("threshold") is not None:
        cargs.extend([
            "-threshold",
            str(params.get("threshold"))
        ])
    if params.get("connectivity"):
        cargs.append("-connectivity")
    if params.get("info"):
        cargs.append("-info")
    if params.get("quiet"):
        cargs.append("-quiet")
    if params.get("debug"):
        cargs.append("-debug")
    if params.get("force"):
        cargs.append("-force")
    if params.get("nthreads") is not None:
        cargs.extend([
            "-nthreads",
            str(params.get("nthreads"))
        ])
    if params.get("config") is not None:
        cargs.extend([a for c in [dyn_cargs(s["__STYXTYPE__"])(s, execution) for s in params.get("config")] for a in c])
    if params.get("help"):
        cargs.append("-help")
    if params.get("version"):
        cargs.append("-version")
    cargs.append(execution.input_file(params.get("input")))
    cargs.append(execution.input_file(params.get("design")))
    cargs.append(execution.input_file(params.get("contrast")))
    cargs.append(execution.input_file(params.get("mask")))
    cargs.append(params.get("output"))
    return cargs


def mrclusterstats_outputs(
    params: MrclusterstatsParameters,
    execution: Execution,
) -> MrclusterstatsOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MrclusterstatsOutputs(
        root=execution.output_file("."),
    )
    return ret


def mrclusterstats_execute(
    params: MrclusterstatsParameters,
    execution: Execution,
) -> MrclusterstatsOutputs:
    """
    Voxel-based analysis using permutation testing and threshold-free cluster
    enhancement.
    
    In some software packages, a column of ones is automatically added to the
    GLM design matrix; the purpose of this column is to estimate the "global
    intercept", which is the predicted value of the observed variable if all
    explanatory variables were to be zero. However there are rare situations
    where including such a column would not be appropriate for a particular
    experimental design. Hence, in MRtrix3 statistical inference commands, it is
    up to the user to determine whether or not this column of ones should be
    included in their design matrix, and add it explicitly if necessary. The
    contrast matrix must also reflect the presence of this additional column.
    
    References:
    
    * If not using the -threshold command-line option:
    Smith, S. M. & Nichols, T. E. Threshold-free cluster enhancement: Addressing
    problems of smoothing, threshold dependence and localisation in cluster
    inference. NeuroImage, 2009, 44, 83-98
    
    * If using the -nonstationary option:
    Salimi-Khorshidi, G. Smith, S.M. Nichols, T.E. Adjusting the effect of
    nonstationarity in cluster-based and TFCE inference. Neuroimage, 2011,
    54(3), 2006-19.
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MrclusterstatsOutputs`).
    """
    params = execution.params(params)
    cargs = mrclusterstats_cargs(params, execution)
    ret = mrclusterstats_outputs(params, execution)
    execution.run(cargs)
    return ret


def mrclusterstats(
    input_: InputPathType,
    design: InputPathType,
    contrast: InputPathType,
    mask: InputPathType,
    output: str,
    notest: bool = False,
    errors: str | None = None,
    exchange_within: InputPathType | None = None,
    exchange_whole: InputPathType | None = None,
    strong: bool = False,
    nshuffles: int | None = None,
    permutations: InputPathType | None = None,
    nonstationarity: bool = False,
    skew_nonstationarity: float | None = None,
    nshuffles_nonstationarity: int | None = None,
    permutations_nonstationarity: InputPathType | None = None,
    tfce_dh: float | None = None,
    tfce_e: float | None = None,
    tfce_h: float | None = None,
    variance: InputPathType | None = None,
    ftests: InputPathType | None = None,
    fonly: bool = False,
    column: list[MrclusterstatsColumnParameters] | None = None,
    threshold: float | None = None,
    connectivity: bool = False,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[MrclusterstatsConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
    runner: Runner | None = None,
) -> MrclusterstatsOutputs:
    """
    Voxel-based analysis using permutation testing and threshold-free cluster
    enhancement.
    
    In some software packages, a column of ones is automatically added to the
    GLM design matrix; the purpose of this column is to estimate the "global
    intercept", which is the predicted value of the observed variable if all
    explanatory variables were to be zero. However there are rare situations
    where including such a column would not be appropriate for a particular
    experimental design. Hence, in MRtrix3 statistical inference commands, it is
    up to the user to determine whether or not this column of ones should be
    included in their design matrix, and add it explicitly if necessary. The
    contrast matrix must also reflect the presence of this additional column.
    
    References:
    
    * If not using the -threshold command-line option:
    Smith, S. M. & Nichols, T. E. Threshold-free cluster enhancement: Addressing
    problems of smoothing, threshold dependence and localisation in cluster
    inference. NeuroImage, 2009, 44, 83-98
    
    * If using the -nonstationary option:
    Salimi-Khorshidi, G. Smith, S.M. Nichols, T.E. Adjusting the effect of
    nonstationarity in cluster-based and TFCE inference. Neuroimage, 2011,
    54(3), 2006-19.
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        input_: a text file containing the file names of the input images, one\
            file per line.
        design: the design matrix.
        contrast: the contrast matrix.
        mask: a mask used to define voxels included in the analysis.
        output: the filename prefix for all output.
        notest: don't perform statistical inference; only output population\
            statistics (effect size, stdev etc).
        errors: specify nature of errors for shuffling; options are:\
            ee,ise,both (default: ee).
        exchange_within: specify blocks of observations within each of which\
            data may undergo restricted exchange.
        exchange_whole: specify blocks of observations that may be exchanged\
            with one another (for independent and symmetric errors, sign-flipping\
            will occur block-wise).
        strong: use strong familywise error control across multiple hypotheses.
        nshuffles: the number of shuffles (default: 5000).
        permutations: manually define the permutations (relabelling). The input\
            should be a text file defining a m x n matrix, where each relabelling\
            is defined as a column vector of size m, and the number of columns, n,\
            defines the number of permutations. Can be generated with the\
            palm_quickperms function in PALM\
            (http://fsl.fmrib.ox.ac.uk/fsl/fslwiki/PALM). Overrides the -nshuffles\
            option.
        nonstationarity: perform non-stationarity correction.
        skew_nonstationarity: specify the skew parameter for empirical\
            statistic calculation (default for this command is 1).
        nshuffles_nonstationarity: the number of shuffles to use when\
            precomputing the empirical statistic image for non-stationarity\
            correction (default: 5000).
        permutations_nonstationarity: manually define the permutations\
            (relabelling) for computing the emprical statistics for\
            non-stationarity correction. The input should be a text file defining a\
            m x n matrix, where each relabelling is defined as a column vector of\
            size m, and the number of columns, n, defines the number of\
            permutations. Can be generated with the palm_quickperms function in\
            PALM (http://fsl.fmrib.ox.ac.uk/fsl/fslwiki/PALM) Overrides the\
            -nshuffles_nonstationarity option.
        tfce_dh: the height increment used in the tfce integration (default:\
            0.1).
        tfce_e: tfce extent exponent (default: 0.5).
        tfce_h: tfce height exponent (default: 2).
        variance: define variance groups for the G-statistic; measurements for\
            which the expected variance is equivalent should contain the same index.
        ftests: perform F-tests; input text file should contain, for each\
            F-test, a row containing ones and zeros, where ones indicate the rows\
            of the contrast matrix to be included in the F-test.
        fonly: only assess F-tests; do not perform statistical inference on\
            entries in the contrast matrix.
        column: add a column to the design matrix corresponding to subject\
            voxel-wise values (note that the contrast matrix must include an\
            additional column for each use of this option); the text file provided\
            via this option should contain a file name for each subject.
        threshold: the cluster-forming threshold to use for a standard\
            cluster-based analysis. This disables TFCE, which is the default\
            otherwise.
        connectivity: use 26-voxel-neighbourhood connectivity (Default: 6).
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MrclusterstatsOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MRCLUSTERSTATS_METADATA)
    params = mrclusterstats_params(
        notest=notest,
        errors=errors,
        exchange_within=exchange_within,
        exchange_whole=exchange_whole,
        strong=strong,
        nshuffles=nshuffles,
        permutations=permutations,
        nonstationarity=nonstationarity,
        skew_nonstationarity=skew_nonstationarity,
        nshuffles_nonstationarity=nshuffles_nonstationarity,
        permutations_nonstationarity=permutations_nonstationarity,
        tfce_dh=tfce_dh,
        tfce_e=tfce_e,
        tfce_h=tfce_h,
        variance=variance,
        ftests=ftests,
        fonly=fonly,
        column=column,
        threshold=threshold,
        connectivity=connectivity,
        info=info,
        quiet=quiet,
        debug=debug,
        force=force,
        nthreads=nthreads,
        config=config,
        help_=help_,
        version=version,
        input_=input_,
        design=design,
        contrast=contrast,
        mask=mask,
        output=output,
    )
    return mrclusterstats_execute(params, execution)


__all__ = [
    "MRCLUSTERSTATS_METADATA",
    "MrclusterstatsColumnParameters",
    "MrclusterstatsConfigParameters",
    "MrclusterstatsOutputs",
    "MrclusterstatsParameters",
    "mrclusterstats",
    "mrclusterstats_column_params",
    "mrclusterstats_config_params",
    "mrclusterstats_params",
]
