# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

MRTHRESHOLD_METADATA = Metadata(
    id="63955d6506c219775e9ca4df901c67a97355416d.boutiques",
    name="mrthreshold",
    package="mrtrix",
    container_image_tag="mrtrix3/mrtrix3:3.0.4",
)


MrthresholdConfigParameters = typing.TypedDict('MrthresholdConfigParameters', {
    "__STYX_TYPE__": typing.Literal["config"],
    "key": str,
    "value": str,
})


MrthresholdParameters = typing.TypedDict('MrthresholdParameters', {
    "__STYX_TYPE__": typing.Literal["mrthreshold"],
    "abs": typing.NotRequired[float | None],
    "percentile": typing.NotRequired[float | None],
    "top": typing.NotRequired[int | None],
    "bottom": typing.NotRequired[int | None],
    "allvolumes": bool,
    "ignorezero": bool,
    "mask": typing.NotRequired[InputPathType | None],
    "comparison": typing.NotRequired[str | None],
    "invert": bool,
    "out_masked": bool,
    "nan": bool,
    "info": bool,
    "quiet": bool,
    "debug": bool,
    "force": bool,
    "nthreads": typing.NotRequired[int | None],
    "config": typing.NotRequired[list[MrthresholdConfigParameters] | None],
    "help": bool,
    "version": bool,
    "input": InputPathType,
    "output": typing.NotRequired[str | None],
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "mrthreshold": mrthreshold_cargs,
        "config": mrthreshold_config_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "mrthreshold": mrthreshold_outputs,
    }.get(t)


def mrthreshold_config_params(
    key: str,
    value: str,
) -> MrthresholdConfigParameters:
    """
    Build parameters.
    
    Args:
        key: temporarily set the value of an MRtrix config file entry.
        value: temporarily set the value of an MRtrix config file entry.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "config",
        "key": key,
        "value": value,
    }
    return params


def mrthreshold_config_cargs(
    params: MrthresholdConfigParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("-config")
    cargs.append(params.get("key"))
    cargs.append(params.get("value"))
    return cargs


class MrthresholdOutputs(typing.NamedTuple):
    """
    Output object returned when calling `mrthreshold(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output: OutputPathType | None
    """the (optional) output binary image mask"""


def mrthreshold_params(
    input_: InputPathType,
    abs_: float | None = None,
    percentile: float | None = None,
    top: int | None = None,
    bottom: int | None = None,
    allvolumes: bool = False,
    ignorezero: bool = False,
    mask: InputPathType | None = None,
    comparison: str | None = None,
    invert: bool = False,
    out_masked: bool = False,
    nan: bool = False,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[MrthresholdConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
    output: str | None = None,
) -> MrthresholdParameters:
    """
    Build parameters.
    
    Args:
        input_: the input image to be thresholded.
        abs_: specify threshold value as absolute intensity.
        percentile: determine threshold based on some percentile of the image\
            intensity distribution.
        top: determine threshold that will result in selection of some number\
            of top-valued voxels.
        bottom: determine & apply threshold resulting in selection of some\
            number of bottom-valued voxels (note: implies threshold application\
            operator of "le" unless otherwise specified).
        allvolumes: compute a single threshold for all image volumes, rather\
            than an individual threshold per volume.
        ignorezero: ignore zero-valued input values during threshold\
            determination.
        mask: compute the threshold based only on values within an input mask\
            image.
        comparison: comparison operator to use when applying the threshold;\
            options are: lt,le,ge,gt (default = "le" for -bottom; "ge" otherwise).
        invert: invert the output binary mask (equivalent to flipping the\
            operator; provided for backwards compatibility).
        out_masked: mask the output image based on the provided input mask\
            image.
        nan: set voxels that fail the threshold to NaN rather than zero (output\
            image will be floating-point rather than binary).
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
        output: the (optional) output binary image mask.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "mrthreshold",
        "allvolumes": allvolumes,
        "ignorezero": ignorezero,
        "invert": invert,
        "out_masked": out_masked,
        "nan": nan,
        "info": info,
        "quiet": quiet,
        "debug": debug,
        "force": force,
        "help": help_,
        "version": version,
        "input": input_,
    }
    if abs_ is not None:
        params["abs"] = abs_
    if percentile is not None:
        params["percentile"] = percentile
    if top is not None:
        params["top"] = top
    if bottom is not None:
        params["bottom"] = bottom
    if mask is not None:
        params["mask"] = mask
    if comparison is not None:
        params["comparison"] = comparison
    if nthreads is not None:
        params["nthreads"] = nthreads
    if config is not None:
        params["config"] = config
    if output is not None:
        params["output"] = output
    return params


def mrthreshold_cargs(
    params: MrthresholdParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("mrthreshold")
    if params.get("abs") is not None:
        cargs.extend([
            "-abs",
            str(params.get("abs"))
        ])
    if params.get("percentile") is not None:
        cargs.extend([
            "-percentile",
            str(params.get("percentile"))
        ])
    if params.get("top") is not None:
        cargs.extend([
            "-top",
            str(params.get("top"))
        ])
    if params.get("bottom") is not None:
        cargs.extend([
            "-bottom",
            str(params.get("bottom"))
        ])
    if params.get("allvolumes"):
        cargs.append("-allvolumes")
    if params.get("ignorezero"):
        cargs.append("-ignorezero")
    if params.get("mask") is not None:
        cargs.extend([
            "-mask",
            execution.input_file(params.get("mask"))
        ])
    if params.get("comparison") is not None:
        cargs.extend([
            "-comparison",
            params.get("comparison")
        ])
    if params.get("invert"):
        cargs.append("-invert")
    if params.get("out_masked"):
        cargs.append("-out_masked")
    if params.get("nan"):
        cargs.append("-nan")
    if params.get("info"):
        cargs.append("-info")
    if params.get("quiet"):
        cargs.append("-quiet")
    if params.get("debug"):
        cargs.append("-debug")
    if params.get("force"):
        cargs.append("-force")
    if params.get("nthreads") is not None:
        cargs.extend([
            "-nthreads",
            str(params.get("nthreads"))
        ])
    if params.get("config") is not None:
        cargs.extend([a for c in [dyn_cargs(s["__STYXTYPE__"])(s, execution) for s in params.get("config")] for a in c])
    if params.get("help"):
        cargs.append("-help")
    if params.get("version"):
        cargs.append("-version")
    cargs.append(execution.input_file(params.get("input")))
    if params.get("output") is not None:
        cargs.append(params.get("output"))
    return cargs


def mrthreshold_outputs(
    params: MrthresholdParameters,
    execution: Execution,
) -> MrthresholdOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = MrthresholdOutputs(
        root=execution.output_file("."),
        output=execution.output_file(params.get("output")) if (params.get("output") is not None) else None,
    )
    return ret


def mrthreshold_execute(
    params: MrthresholdParameters,
    execution: Execution,
) -> MrthresholdOutputs:
    """
    Create bitwise image by thresholding image intensity.
    
    The threshold value to be applied can be determined in one of a number of
    ways:
    
    - If no relevant command-line option is used, the command will automatically
    determine an optimal threshold;
    
    - The -abs option provides the threshold value explicitly;
    
    - The -percentile, -top and -bottom options enable more fine-grained control
    over how the threshold value is determined.
    
    The -mask option only influences those image values that contribute toward
    the determination of the threshold value; once the threshold is determined,
    it is applied to the entire image, irrespective of use of the -mask option.
    If you wish for the voxels outside of the specified mask to additionally be
    excluded from the output mask, this can be achieved by providing the
    -out_masked option.
    
    The four operators available through the "-comparison" option ("lt", "le",
    "ge" and "gt") correspond to "less-than" (<), "less-than-or-equal" (<=),
    "greater-than-or-equal" (>=) and "greater-than" (>). This offers
    fine-grained control over how the thresholding operation will behave in the
    presence of values equivalent to the threshold. By default, the command will
    select voxels with values greater than or equal to the determined threshold
    ("ge"); unless the -bottom option is used, in which case after a threshold
    is determined from the relevant lowest-valued image voxels, those voxels
    with values less than or equal to that threshold ("le") are selected. This
    provides more fine-grained control than the -invert option; the latter is
    provided for backwards compatibility, but is equivalent to selection of the
    opposite comparison within this selection.
    
    If no output image path is specified, the command will instead write to
    standard output the determined threshold value.
    
    References:
    
    * If not using any explicit thresholding mechanism:
    Ridgway, G. R.; Omar, R.; Ourselin, S.; Hill, D. L.; Warren, J. D. & Fox, N.
    C. Issues with threshold masking in voxel-based morphometry of atrophied
    brains. NeuroImage, 2009, 44, 99-111.
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `MrthresholdOutputs`).
    """
    params = execution.params(params)
    cargs = mrthreshold_cargs(params, execution)
    ret = mrthreshold_outputs(params, execution)
    execution.run(cargs)
    return ret


def mrthreshold(
    input_: InputPathType,
    abs_: float | None = None,
    percentile: float | None = None,
    top: int | None = None,
    bottom: int | None = None,
    allvolumes: bool = False,
    ignorezero: bool = False,
    mask: InputPathType | None = None,
    comparison: str | None = None,
    invert: bool = False,
    out_masked: bool = False,
    nan: bool = False,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[MrthresholdConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
    output: str | None = None,
    runner: Runner | None = None,
) -> MrthresholdOutputs:
    """
    Create bitwise image by thresholding image intensity.
    
    The threshold value to be applied can be determined in one of a number of
    ways:
    
    - If no relevant command-line option is used, the command will automatically
    determine an optimal threshold;
    
    - The -abs option provides the threshold value explicitly;
    
    - The -percentile, -top and -bottom options enable more fine-grained control
    over how the threshold value is determined.
    
    The -mask option only influences those image values that contribute toward
    the determination of the threshold value; once the threshold is determined,
    it is applied to the entire image, irrespective of use of the -mask option.
    If you wish for the voxels outside of the specified mask to additionally be
    excluded from the output mask, this can be achieved by providing the
    -out_masked option.
    
    The four operators available through the "-comparison" option ("lt", "le",
    "ge" and "gt") correspond to "less-than" (<), "less-than-or-equal" (<=),
    "greater-than-or-equal" (>=) and "greater-than" (>). This offers
    fine-grained control over how the thresholding operation will behave in the
    presence of values equivalent to the threshold. By default, the command will
    select voxels with values greater than or equal to the determined threshold
    ("ge"); unless the -bottom option is used, in which case after a threshold
    is determined from the relevant lowest-valued image voxels, those voxels
    with values less than or equal to that threshold ("le") are selected. This
    provides more fine-grained control than the -invert option; the latter is
    provided for backwards compatibility, but is equivalent to selection of the
    opposite comparison within this selection.
    
    If no output image path is specified, the command will instead write to
    standard output the determined threshold value.
    
    References:
    
    * If not using any explicit thresholding mechanism:
    Ridgway, G. R.; Omar, R.; Ourselin, S.; Hill, D. L.; Warren, J. D. & Fox, N.
    C. Issues with threshold masking in voxel-based morphometry of atrophied
    brains. NeuroImage, 2009, 44, 99-111.
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        input_: the input image to be thresholded.
        abs_: specify threshold value as absolute intensity.
        percentile: determine threshold based on some percentile of the image\
            intensity distribution.
        top: determine threshold that will result in selection of some number\
            of top-valued voxels.
        bottom: determine & apply threshold resulting in selection of some\
            number of bottom-valued voxels (note: implies threshold application\
            operator of "le" unless otherwise specified).
        allvolumes: compute a single threshold for all image volumes, rather\
            than an individual threshold per volume.
        ignorezero: ignore zero-valued input values during threshold\
            determination.
        mask: compute the threshold based only on values within an input mask\
            image.
        comparison: comparison operator to use when applying the threshold;\
            options are: lt,le,ge,gt (default = "le" for -bottom; "ge" otherwise).
        invert: invert the output binary mask (equivalent to flipping the\
            operator; provided for backwards compatibility).
        out_masked: mask the output image based on the provided input mask\
            image.
        nan: set voxels that fail the threshold to NaN rather than zero (output\
            image will be floating-point rather than binary).
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
        output: the (optional) output binary image mask.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `MrthresholdOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(MRTHRESHOLD_METADATA)
    params = mrthreshold_params(
        abs_=abs_,
        percentile=percentile,
        top=top,
        bottom=bottom,
        allvolumes=allvolumes,
        ignorezero=ignorezero,
        mask=mask,
        comparison=comparison,
        invert=invert,
        out_masked=out_masked,
        nan=nan,
        info=info,
        quiet=quiet,
        debug=debug,
        force=force,
        nthreads=nthreads,
        config=config,
        help_=help_,
        version=version,
        input_=input_,
        output=output,
    )
    return mrthreshold_execute(params, execution)


__all__ = [
    "MRTHRESHOLD_METADATA",
    "MrthresholdConfigParameters",
    "MrthresholdOutputs",
    "MrthresholdParameters",
    "mrthreshold",
    "mrthreshold_config_params",
    "mrthreshold_params",
]
