# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

TSFTHRESHOLD_METADATA = Metadata(
    id="ba9d0cc1c0a9bce1ed01fd391b2bc14adc5c7f6e.boutiques",
    name="tsfthreshold",
    package="mrtrix",
    container_image_tag="mrtrix3/mrtrix3:3.0.4",
)


TsfthresholdConfigParameters = typing.TypedDict('TsfthresholdConfigParameters', {
    "__STYX_TYPE__": typing.Literal["config"],
    "key": str,
    "value": str,
})


TsfthresholdParameters = typing.TypedDict('TsfthresholdParameters', {
    "__STYX_TYPE__": typing.Literal["tsfthreshold"],
    "invert": bool,
    "info": bool,
    "quiet": bool,
    "debug": bool,
    "force": bool,
    "nthreads": typing.NotRequired[int | None],
    "config": typing.NotRequired[list[TsfthresholdConfigParameters] | None],
    "help": bool,
    "version": bool,
    "input": InputPathType,
    "T": float,
    "output": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "tsfthreshold": tsfthreshold_cargs,
        "config": tsfthreshold_config_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "tsfthreshold": tsfthreshold_outputs,
    }.get(t)


def tsfthreshold_config_params(
    key: str,
    value: str,
) -> TsfthresholdConfigParameters:
    """
    Build parameters.
    
    Args:
        key: temporarily set the value of an MRtrix config file entry.
        value: temporarily set the value of an MRtrix config file entry.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "config",
        "key": key,
        "value": value,
    }
    return params


def tsfthreshold_config_cargs(
    params: TsfthresholdConfigParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("-config")
    cargs.append(params.get("key"))
    cargs.append(params.get("value"))
    return cargs


class TsfthresholdOutputs(typing.NamedTuple):
    """
    Output object returned when calling `tsfthreshold(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output: OutputPathType
    """the binary output track scalar file"""


def tsfthreshold_params(
    input_: InputPathType,
    t: float,
    output: str,
    invert: bool = False,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[TsfthresholdConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
) -> TsfthresholdParameters:
    """
    Build parameters.
    
    Args:
        input_: the input track scalar file.
        t: the desired threshold.
        output: the binary output track scalar file.
        invert: invert the output mask.
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "tsfthreshold",
        "invert": invert,
        "info": info,
        "quiet": quiet,
        "debug": debug,
        "force": force,
        "help": help_,
        "version": version,
        "input": input_,
        "T": t,
        "output": output,
    }
    if nthreads is not None:
        params["nthreads"] = nthreads
    if config is not None:
        params["config"] = config
    return params


def tsfthreshold_cargs(
    params: TsfthresholdParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("tsfthreshold")
    if params.get("invert"):
        cargs.append("-invert")
    if params.get("info"):
        cargs.append("-info")
    if params.get("quiet"):
        cargs.append("-quiet")
    if params.get("debug"):
        cargs.append("-debug")
    if params.get("force"):
        cargs.append("-force")
    if params.get("nthreads") is not None:
        cargs.extend([
            "-nthreads",
            str(params.get("nthreads"))
        ])
    if params.get("config") is not None:
        cargs.extend([a for c in [dyn_cargs(s["__STYXTYPE__"])(s, execution) for s in params.get("config")] for a in c])
    if params.get("help"):
        cargs.append("-help")
    if params.get("version"):
        cargs.append("-version")
    cargs.append(execution.input_file(params.get("input")))
    cargs.append(str(params.get("T")))
    cargs.append(params.get("output"))
    return cargs


def tsfthreshold_outputs(
    params: TsfthresholdParameters,
    execution: Execution,
) -> TsfthresholdOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = TsfthresholdOutputs(
        root=execution.output_file("."),
        output=execution.output_file(params.get("output")),
    )
    return ret


def tsfthreshold_execute(
    params: TsfthresholdParameters,
    execution: Execution,
) -> TsfthresholdOutputs:
    """
    Threshold and invert track scalar files.
    
    
    
    References:
    
    .
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `TsfthresholdOutputs`).
    """
    params = execution.params(params)
    cargs = tsfthreshold_cargs(params, execution)
    ret = tsfthreshold_outputs(params, execution)
    execution.run(cargs)
    return ret


def tsfthreshold(
    input_: InputPathType,
    t: float,
    output: str,
    invert: bool = False,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[TsfthresholdConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
    runner: Runner | None = None,
) -> TsfthresholdOutputs:
    """
    Threshold and invert track scalar files.
    
    
    
    References:
    
    .
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        input_: the input track scalar file.
        t: the desired threshold.
        output: the binary output track scalar file.
        invert: invert the output mask.
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `TsfthresholdOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(TSFTHRESHOLD_METADATA)
    params = tsfthreshold_params(
        invert=invert,
        info=info,
        quiet=quiet,
        debug=debug,
        force=force,
        nthreads=nthreads,
        config=config,
        help_=help_,
        version=version,
        input_=input_,
        t=t,
        output=output,
    )
    return tsfthreshold_execute(params, execution)


__all__ = [
    "TSFTHRESHOLD_METADATA",
    "TsfthresholdConfigParameters",
    "TsfthresholdOutputs",
    "TsfthresholdParameters",
    "tsfthreshold",
    "tsfthreshold_config_params",
    "tsfthreshold_params",
]
