# This file was auto generated by Styx.
# Do not edit this file directly.

import typing
import pathlib
from styxdefs import *

V_5TTEDIT_METADATA = Metadata(
    id="2f89d4273f8dafe192690c3eb53a171d1d583a82.boutiques",
    name="5ttedit",
    package="mrtrix",
    container_image_tag="mrtrix3/mrtrix3:3.0.4",
)


V5tteditConfigParameters = typing.TypedDict('V5tteditConfigParameters', {
    "__STYX_TYPE__": typing.Literal["config"],
    "key": str,
    "value": str,
})


V5tteditParameters = typing.TypedDict('V5tteditParameters', {
    "__STYX_TYPE__": typing.Literal["5ttedit"],
    "cgm": typing.NotRequired[InputPathType | None],
    "sgm": typing.NotRequired[InputPathType | None],
    "wm": typing.NotRequired[InputPathType | None],
    "csf": typing.NotRequired[InputPathType | None],
    "path": typing.NotRequired[InputPathType | None],
    "none": typing.NotRequired[InputPathType | None],
    "info": bool,
    "quiet": bool,
    "debug": bool,
    "force": bool,
    "nthreads": typing.NotRequired[int | None],
    "config": typing.NotRequired[list[V5tteditConfigParameters] | None],
    "help": bool,
    "version": bool,
    "input": InputPathType,
    "output": str,
})


def dyn_cargs(
    t: str,
) -> typing.Any:
    """
    Get build cargs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build cargs function.
    """
    return {
        "5ttedit": v_5ttedit_cargs,
        "config": v_5ttedit_config_cargs,
    }.get(t)


def dyn_outputs(
    t: str,
) -> typing.Any:
    """
    Get build outputs function by command type.
    
    Args:
        t: Command type.
    Returns:
        Build outputs function.
    """
    return {
        "5ttedit": v_5ttedit_outputs,
    }.get(t)


def v_5ttedit_config_params(
    key: str,
    value: str,
) -> V5tteditConfigParameters:
    """
    Build parameters.
    
    Args:
        key: temporarily set the value of an MRtrix config file entry.
        value: temporarily set the value of an MRtrix config file entry.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "config",
        "key": key,
        "value": value,
    }
    return params


def v_5ttedit_config_cargs(
    params: V5tteditConfigParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("-config")
    cargs.append(params.get("key"))
    cargs.append(params.get("value"))
    return cargs


class V5tteditOutputs(typing.NamedTuple):
    """
    Output object returned when calling `v_5ttedit(...)`.
    """
    root: OutputPathType
    """Output root folder. This is the root folder for all outputs."""
    output: OutputPathType
    """the output modified 5TT image"""


def v_5ttedit_params(
    input_: InputPathType,
    output: str,
    cgm: InputPathType | None = None,
    sgm: InputPathType | None = None,
    wm: InputPathType | None = None,
    csf: InputPathType | None = None,
    path: InputPathType | None = None,
    none: InputPathType | None = None,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[V5tteditConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
) -> V5tteditParameters:
    """
    Build parameters.
    
    Args:
        input_: the 5TT image to be modified.
        output: the output modified 5TT image.
        cgm: provide a mask of voxels that should be set to cortical grey\
            matter.
        sgm: provide a mask of voxels that should be set to sub-cortical grey\
            matter.
        wm: provide a mask of voxels that should be set to white matter.
        csf: provide a mask of voxels that should be set to CSF.
        path: provide a mask of voxels that should be set to pathological\
            tissue.
        none: provide a mask of voxels that should be cleared (i.e. are\
            non-brain); note that this will supersede all other provided masks.
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
    Returns:
        Parameter dictionary
    """
    params = {
        "__STYXTYPE__": "5ttedit",
        "info": info,
        "quiet": quiet,
        "debug": debug,
        "force": force,
        "help": help_,
        "version": version,
        "input": input_,
        "output": output,
    }
    if cgm is not None:
        params["cgm"] = cgm
    if sgm is not None:
        params["sgm"] = sgm
    if wm is not None:
        params["wm"] = wm
    if csf is not None:
        params["csf"] = csf
    if path is not None:
        params["path"] = path
    if none is not None:
        params["none"] = none
    if nthreads is not None:
        params["nthreads"] = nthreads
    if config is not None:
        params["config"] = config
    return params


def v_5ttedit_cargs(
    params: V5tteditParameters,
    execution: Execution,
) -> list[str]:
    """
    Build command-line arguments from parameters.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Command-line arguments.
    """
    cargs = []
    cargs.append("5ttedit")
    if params.get("cgm") is not None:
        cargs.extend([
            "-cgm",
            execution.input_file(params.get("cgm"))
        ])
    if params.get("sgm") is not None:
        cargs.extend([
            "-sgm",
            execution.input_file(params.get("sgm"))
        ])
    if params.get("wm") is not None:
        cargs.extend([
            "-wm",
            execution.input_file(params.get("wm"))
        ])
    if params.get("csf") is not None:
        cargs.extend([
            "-csf",
            execution.input_file(params.get("csf"))
        ])
    if params.get("path") is not None:
        cargs.extend([
            "-path",
            execution.input_file(params.get("path"))
        ])
    if params.get("none") is not None:
        cargs.extend([
            "-none",
            execution.input_file(params.get("none"))
        ])
    if params.get("info"):
        cargs.append("-info")
    if params.get("quiet"):
        cargs.append("-quiet")
    if params.get("debug"):
        cargs.append("-debug")
    if params.get("force"):
        cargs.append("-force")
    if params.get("nthreads") is not None:
        cargs.extend([
            "-nthreads",
            str(params.get("nthreads"))
        ])
    if params.get("config") is not None:
        cargs.extend([a for c in [dyn_cargs(s["__STYXTYPE__"])(s, execution) for s in params.get("config")] for a in c])
    if params.get("help"):
        cargs.append("-help")
    if params.get("version"):
        cargs.append("-version")
    cargs.append(execution.input_file(params.get("input")))
    cargs.append(params.get("output"))
    return cargs


def v_5ttedit_outputs(
    params: V5tteditParameters,
    execution: Execution,
) -> V5tteditOutputs:
    """
    Build outputs object containing output file paths and possibly stdout/stderr.
    
    Args:
        params: The parameters.
        execution: The execution object for resolving input paths.
    Returns:
        Outputs object.
    """
    ret = V5tteditOutputs(
        root=execution.output_file("."),
        output=execution.output_file(params.get("output")),
    )
    return ret


def v_5ttedit_execute(
    params: V5tteditParameters,
    execution: Execution,
) -> V5tteditOutputs:
    """
    Manually set the partial volume fractions in an ACT five-tissue-type (5TT) image
    using mask images.
    
    
    
    References:
    
    .
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        params: The parameters.
        execution: The execution object.
    Returns:
        NamedTuple of outputs (described in `V5tteditOutputs`).
    """
    params = execution.params(params)
    cargs = v_5ttedit_cargs(params, execution)
    ret = v_5ttedit_outputs(params, execution)
    execution.run(cargs)
    return ret


def v_5ttedit(
    input_: InputPathType,
    output: str,
    cgm: InputPathType | None = None,
    sgm: InputPathType | None = None,
    wm: InputPathType | None = None,
    csf: InputPathType | None = None,
    path: InputPathType | None = None,
    none: InputPathType | None = None,
    info: bool = False,
    quiet: bool = False,
    debug: bool = False,
    force: bool = False,
    nthreads: int | None = None,
    config: list[V5tteditConfigParameters] | None = None,
    help_: bool = False,
    version: bool = False,
    runner: Runner | None = None,
) -> V5tteditOutputs:
    """
    Manually set the partial volume fractions in an ACT five-tissue-type (5TT) image
    using mask images.
    
    
    
    References:
    
    .
    
    Author: MRTrix3 Developers
    
    URL: https://www.mrtrix.org/
    
    Args:
        input_: the 5TT image to be modified.
        output: the output modified 5TT image.
        cgm: provide a mask of voxels that should be set to cortical grey\
            matter.
        sgm: provide a mask of voxels that should be set to sub-cortical grey\
            matter.
        wm: provide a mask of voxels that should be set to white matter.
        csf: provide a mask of voxels that should be set to CSF.
        path: provide a mask of voxels that should be set to pathological\
            tissue.
        none: provide a mask of voxels that should be cleared (i.e. are\
            non-brain); note that this will supersede all other provided masks.
        info: display information messages.
        quiet: do not display information messages or progress status;\
            alternatively, this can be achieved by setting the MRTRIX_QUIET\
            environment variable to a non-empty string.
        debug: display debugging messages.
        force: force overwrite of output files (caution: using the same file as\
            input and output might cause unexpected behaviour).
        nthreads: use this number of threads in multi-threaded applications\
            (set to 0 to disable multi-threading).
        config: temporarily set the value of an MRtrix config file entry.
        help_: display this information page and exit.
        version: display version information and exit.
        runner: Command runner.
    Returns:
        NamedTuple of outputs (described in `V5tteditOutputs`).
    """
    runner = runner or get_global_runner()
    execution = runner.start_execution(V_5TTEDIT_METADATA)
    params = v_5ttedit_params(
        cgm=cgm,
        sgm=sgm,
        wm=wm,
        csf=csf,
        path=path,
        none=none,
        info=info,
        quiet=quiet,
        debug=debug,
        force=force,
        nthreads=nthreads,
        config=config,
        help_=help_,
        version=version,
        input_=input_,
        output=output,
    )
    return v_5ttedit_execute(params, execution)


__all__ = [
    "V5tteditConfigParameters",
    "V5tteditOutputs",
    "V5tteditParameters",
    "V_5TTEDIT_METADATA",
    "v_5ttedit",
    "v_5ttedit_config_params",
    "v_5ttedit_params",
]
